<?php
/**
 * Yourstyle+ Admin Column IDs
 *
 * @package     Yourstyle_Plus_Companion_Plugin
 * @subpackage  Yourstyle_Plus_Companion_Plugin/addons
 * @since       1.1.0
 * @author      Bjorn Manintveld
 * @link        https://your-style.nl/
 * @version     1.0.0
 * 
 */

if (!class_exists('ysp_admin_column_ids')) {

    class ysp_admin_column_ids
    {

        // Lets run some basics
        function __construct()
        {
            
            // Add the ID column to Posts, Pages and Media
            add_filter('manage_media_columns', array($this, 'ysp_media_column_id'));
            add_filter('manage_media_custom_column', array($this, 'ysp_media_column_id_row'), 10, 2);

            add_filter('manage_pages_columns', array($this, 'ysp_media_column_id'));
            add_filter('manage_pages_custom_column', array($this, 'ysp_media_column_id_row'), 10, 2);

            add_filter('manage_posts_columns', array($this, 'ysp_media_column_id'));
            add_filter('manage_posts_custom_column', array($this, 'ysp_media_column_id_row'), 10, 2);
            
        }

        function ysp_media_column_id($columns) {
            $columns['colID'] = __('ID', 'yourstyle-plus-companion-plugin');
            return $columns;
        }

        function ysp_media_column_id_row($columnName, $columnID) {
            if ($columnName == 'colID') {
                echo $columnID;
            }
        }

    }

    $ysp_admin_column_ids = new ysp_admin_column_ids();

}