<?php
/**
 * Yourstyle+ Hang Nav
 *
 * @package     Yourstyle_Plus_Companion_Plugin
 * @subpackage  Yourstyle_Plus_Companion_Plugin/addons
 * @since       1.0.0
 * @author      Thomas Bulten
 * @link        https://your-style.nl/
 * @version     1.0.0
 * 
 */

if ( ! class_exists( 'YspHangNav' ) ) {

    class YspHangNav
    {

        // Lets run some basics
        function __construct()
        {
            
            // Enqueue Hang Nav script and style.
            add_action('ysp_after_header_inner', array($this, 'ysp_hang_navigation'));
            
        }

        // Enqueue Hang Nav script and style.
        function ysp_hang_navigation()
        {

            $menu_align = ysp_get_option('ysp-hang-navigation-position');
            switch ($menu_align) {
                case 'lft':
                    $align = ' nav--left';
                    break;
                case 'cnt':
                    $align = ' nav--center';
                    break;
                case 'rgt':
                    $align = ' nav--right';
                    break;
                default:
                    $align = ' nav--left';
            }
            
            $menu = 'site-header-two';
            if ( has_nav_menu( $menu ) ) {
                echo '<div class="hang-navigation">';
                    echo '<div class="c-container">';
                        echo '<div class="c-row">';
                            echo '<div class="c-col">';
                                echo '<nav id="site-navigation-two" class="secondary-navigation'. $align .' u-d-none u-d-lg-flex" role="navigation">';
                                    ysp_navigation( $menu );
                                echo'</nav>';
                            echo'</div>';
                        echo'</div>';
                    echo'</div>';
                echo '</div><!-- #site-nav -->';
            }
        }
    }

    $YspHangNav = new YspHangNav();

}