<?php
/**
 * Yourstyle+ Widget Accordion
 *
 * @package     Yourstyle_Plus_Companion_Plugin
 * @subpackage  Yourstyle_Plus_Companion_Plugin/addons
 * @since       1.6.0
 * @author      Thomas Bulten
 * @link        https://your-style.nl/
 * @version     1.0.0
 * 
 */

if ( ! class_exists( 'YspWidgetAccordion' ) ) {

    class YspWidgetAccordion {

        // Lets run some basics
        function __construct() {
		
            // Widget Accordion
            add_action( 'init', array( $this, 'load_dependencies' ) );
            
            // Enqueue Widget Accordion script and style.
            add_action( 'wp_enqueue_scripts', array( $this, 'ysp_enqueue_widget_accordion' ) );

        }

        // Load Dependencies
        public function load_dependencies() {

            // Add Shortcode
            require_once YSP_COMPANION_DIR . 'public/partials/components/shortcodes/class-widget-accordion.php';

            // Add Visual Composer
            require_once YSP_COMPANION_DIR . 'public/partials/components/visual-composer/widget-accordion-to-vc.php';
        }

        // Enqueue Widget Accordion script and style.
        public function ysp_enqueue_widget_accordion() {

            // Enqueue Style
            wp_register_style( 'ysp-widget-accordion-style', plugin_dir_url( __DIR__ ) . '../public/assets/dist/css/addon-widget-accordion.min.css' );
            wp_enqueue_style( 'ysp-widget-accordion-style' );

            // Enqueue Script
            wp_register_script( 'ysp-widget-accordion-script', plugin_dir_url( __DIR__ ) . '../public/assets/dist/js/addon-widget-accordion.min.js', array( 'jquery' ) );
            wp_enqueue_script( 'ysp-widget-accordion-script' );
        }

    }

    $YspWidgetAccordion = new YspWidgetAccordion();

}