<?php

/**
 * VC Shortcode - Widget Accordion
 *
 * @since 1.0
 */

class YSP_Companion_Widget_Accordion_Shortcode {

	public function __construct() {
		add_shortcode( 'ysp_widget_accordion', array( $this, 'ysp_widget_accordion_shortcode' ) );
	}

	public function ysp_widget_accordion_shortcode( $atts, $content = null ) {
        $options = shortcode_atts(
            array(
                'title' => '',
                'icon_name_start' => '',
                'icon_prefix_start' => 'far',
                'icon_size_start' => '',
                'icon_color_start' => '',
                'icon_class_start' => '',
                'icon_rotate_start' => '',
                'icon_change_start' => '',
                'icon_name_end' => 'chevron-down',
                'icon_prefix_end' => 'far',
                'icon_size_end' => '',
                'icon_color_end' => '',
                'icon_class_end' => '',
                'icon_rotate_end' => 'yes',
                'icon_change_end' => '',
                'collapse'  => 'sm',
                'class' => '',
                'margin'    => '',
                'padding'   => '',
            ), $atts
        );

        $output = '';

        // Collapse
        $collapse = (!empty($options['collapse'])) ? 'c-widget-accordion--collapse-'. $options['collapse'] : '';

        // Classes
        $classes = ysp_getExtraClass(
            array(
                'c-widget-accordion',
                $collapse,
                $options['class'],
                $options['margin'],
                $options['padding'],
            ),
            true
        );

        if ( empty( $content ) ) {
            return;
        }

        // Icon Start
        $icon_name_start = !empty( $options['icon_name_start'] ) ? $options['icon_name_start'] : '';
        $icon_prefix_start = !empty( $options['icon_prefix_start'] ) ? $options['icon_prefix_start'] : '';
        $icon_size_start = !empty( $options['icon_size_start'] ) ? $options['icon_size_start'] : '';
        $icon_color_start = !empty( $options['icon_color_start'] ) ? $options['icon_color_start'] : '';
        $icon_class_start = !empty( $options['icon_class_start'] ) ? $options['icon_class_start'] : '';
        $icon_change_start = !empty( $options['icon_change_start'] ) ? $options['icon_change_start'] : '';

        // Icon Start Args
        $icon_start_args = array(
            'icon_name' => $icon_name_start,
            'icon_prefix' => $icon_prefix_start,
            'icon_size' => $icon_size_start,
            'icon_color' => $icon_color_start,
            'icon_class' => $icon_class_start,
        );
        // Change Icon Start
        $icon_change_start_args = array(
            'icon_name' => $icon_change_start,
            'icon_prefix' => $icon_prefix_start,
            'icon_size' => $icon_size_start,
            'icon_color' => $icon_color_start,
            'icon_class' => $icon_class_start,
        );

        // Icon Start Rotate
        $icon_rotate_start = !empty( $options['icon_rotate_start'] ) ? $options['icon_rotate_start'] : '';
        $icon_rotate_start = ($icon_rotate_start == 'yes') ? ' c-widget-accordion__icon-rotate' : '';
        
        // Icon Change Start
        $icon_change_start_class = !empty( $options['icon_change_start'] ) ? ' c-widget-accordion__icon-change' : '';
        $icon_change_start = ysp_run_icon($icon_change_start_args);

        // Icon Start Run
        $icon_start = ysp_run_icon($icon_start_args);
        $icon_start = !empty($icon_start) && 'never' !== $options['collapse'] ? "<span class=\"c-widget-accordion__icon-start{$icon_rotate_start}{$icon_change_start_class}\">{$icon_start}{$icon_change_start}</span> " : '';

        // Icon End
        $icon_name_end = !empty( $options['icon_name_end'] ) ? $options['icon_name_end'] : '';
        $icon_prefix_end = !empty( $options['icon_prefix_end'] ) ? $options['icon_prefix_end'] : '';
        $icon_size_end = !empty( $options['icon_size_end'] ) ? $options['icon_size_end'] : '';
        $icon_color_end = !empty( $options['icon_color_end'] ) ? $options['icon_color_end'] : '';
        $icon_class_end = !empty( $options['icon_class_end'] ) ? $options['icon_class_end'] : '';
        $icon_change_end = !empty( $options['icon_change_end'] ) ? $options['icon_change_end'] : '';

        // Icon End Args
        $icon_end_args = array(
            'icon_name' => $icon_name_end,
            'icon_prefix' => $icon_prefix_end,
            'icon_size' => $icon_size_end,
            'icon_color' => $icon_color_end,
            'icon_class' => $icon_class_end,
        );
        // Change Icon End
        $icon_change_end_args = array(
            'icon_name' => $icon_change_end,
            'icon_prefix' => $icon_prefix_end,
            'icon_size' => $icon_size_end,
            'icon_color' => $icon_color_end,
            'icon_class' => $icon_class_end,
        );
        
        // Icon End Rotate
        $icon_rotate_end = !empty( $options['icon_rotate_end'] ) ? $options['icon_rotate_end'] : '';
        $icon_rotate_end = ($icon_rotate_end == 'yes') ? ' c-widget-accordion__icon-rotate' : '';
        
        // Icon Change End
        $icon_change_end_class = !empty( $options['icon_change_end'] ) ? ' c-widget-accordion__icon-change' : '';
        $icon_change_end = ysp_run_icon($icon_change_end_args);

        // Icon Start Run
        $icon_end = ysp_run_icon($icon_end_args);
        $icon_end = !empty($icon_end) && 'never' !== $options['collapse'] ? "<span class=\"c-widget-accordion__icon-end{$icon_rotate_end}{$icon_change_end_class}\">{$icon_end}{$icon_change_end}</span>" : '';

        // Title
        $headerStart = '<div class="c-widget-accordion-item__header">'. $icon_start;
        $headerEnd   = $icon_end .'</div>';
        
        // Output Item
        $output .= '<div class="c-widget-accordion-item">';

            // Title
            if ( !empty( $options['title'] ) ) {
                // Title of Widget
                $title = '<span class="c-widget-accordion-item__title">'. $options['title'] .'</span>';
                $output .= $headerStart . $title . $headerEnd;
            }

            // Shortcode
            if ( !empty( $content ) ) {
                $output .= '<div class="c-widget-accordion-item__content">';
                    $output .= do_shortcode( $content );
                $output .= '</div>';
            }
            
        $output .= '</div>';

        return '<div class="'. $classes .'">'. $output .'</div>';
    }

}
new YSP_Companion_Widget_Accordion_Shortcode();