<?php

/**
 * VC Integration - Widget Accordion
 *
 * @since 1.0
 */

add_action( 'vc_before_init', 'ysp_widget_accordion_integrateWithVC' );

function ysp_widget_accordion_integrateWithVC() {

    // Add parameters
    $params = array();

    $params[] = array(
        'type' => 'textfield',
        'heading' => __( 'Title', YSP_COMPANION_TEXT_DOMAIN ),
        'param_name' => 'title',
        'value' => '',
        'admin_label' => true,
        'description' => __( 'Add a title.', YSP_COMPANION_TEXT_DOMAIN ),
    );

    $params[] = array(
        'type' => 'textfield',
        'heading' => __( 'Shortcode', YSP_COMPANION_TEXT_DOMAIN ),
        'param_name' => 'content',
        'value' => '',
        'admin_label' => true,
        'description' => __( 'Place a shortcode you want to display', YSP_COMPANION_TEXT_DOMAIN ),
    );

    // Plugin Check Start
    if ( class_exists('FortAwesome\FontAwesome_Loader') ) {

        /**
         * Icon Start
         */
        $params[] = array(
            'type' => 'textfield',
            'heading' => __('Icon Start | Name', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_name_start',
            'value' => '',
            'group' => esc_html__( 'Icon Start', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Set the icon name ex. chevron-down', YSP_COMPANION_TEXT_DOMAIN),
        );

        $params[] = array(
            'type' => 'dropdown',
            'heading' => __('Icon Start | Prefix', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_prefix_start',
            'value' => array(
                __('Solid', YSP_COMPANION_TEXT_DOMAIN)    =>  'fas',
                __('Regular', YSP_COMPANION_TEXT_DOMAIN)  =>  'far',
                __('Light', YSP_COMPANION_TEXT_DOMAIN)    =>  'fal',
                __('Duotone', YSP_COMPANION_TEXT_DOMAIN)  =>  'fad',
                __('Brands', YSP_COMPANION_TEXT_DOMAIN)   =>  'fab',
            ),
            'std' => 'far',
            'group' => esc_html__( 'Icon Start', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Set the font family type', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'dropdown',
            'heading' => __('Icon Start | Size', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_size_start',
            'value' => ysp_icon_size(),
            'group' => esc_html__( 'Icon Start', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Set the icon size', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'dropdown',
            'heading' => __('Icon Start | Color', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_color_start',
            'value' => ysp_icon_colors(),
            'group' => esc_html__( 'Icon Start', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Set the icon color', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'textfield',
            'heading' => __('Icon Start | Class', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_class_start',
            'value' => '',
            'group' => esc_html__( 'Icon Start', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Add custom CSS class.', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'checkbox',
            'heading' => __('Icon Start | Rotate', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_rotate_start',
            'value' => array(
                __('Yes', YSP_COMPANION_TEXT_DOMAIN) => 'yes'
            ),
            'group' => esc_html__( 'Icon Start', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Let the icon rotate on click.', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'textfield',
            'heading' => __('Icon Start | New Icon', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_change_start',
            'value' => '',
            'group' => esc_html__( 'Icon Start', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Add new icon on click.', YSP_COMPANION_TEXT_DOMAIN),
        );

        /**
         * Icon End
         */
        $params[] = array(
            'type' => 'textfield',
            'heading' => __('Icon End | Name', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_name_end',
            'value' => 'chevron-down',
            'group' => esc_html__( 'Icon End', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Set the icon name ex. chevron-down', YSP_COMPANION_TEXT_DOMAIN),
        );

        $params[] = array(
            'type' => 'dropdown',
            'heading' => __('Icon End | Prefix', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_prefix_end',
            'value' => array(
                __('Solid', YSP_COMPANION_TEXT_DOMAIN)    =>  'fas',
                __('Regular', YSP_COMPANION_TEXT_DOMAIN)  =>  'far',
                __('Light', YSP_COMPANION_TEXT_DOMAIN)    =>  'fal',
                __('Duotone', YSP_COMPANION_TEXT_DOMAIN)  =>  'fad',
                __('Brands', YSP_COMPANION_TEXT_DOMAIN)   =>  'fab',
            ),
            'std' => 'far',
            'group' => esc_html__( 'Icon End', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Set the font family type', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'dropdown',
            'heading' => __('Icon End | Size', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_size_end',
            'value' => ysp_icon_size(),
            'group' => esc_html__( 'Icon End', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Set the icon size', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'dropdown',
            'heading' => __('Icon End | Color', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_color_end',
            'value' => ysp_icon_colors(),
            'group' => esc_html__( 'Icon End', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Set the icon color', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'textfield',
            'heading' => __('Icon End | Class', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_class_end',
            'value' => '',
            'group' => esc_html__( 'Icon End', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Add custom CSS class.', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'checkbox',
            'heading' => __('Icon End | Rotate', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_rotate_end',
            'value' => array(
                __('Yes', YSP_COMPANION_TEXT_DOMAIN) => 'yes'
            ),
            'std' => 'yes',
            'group' => esc_html__( 'Icon End', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Let the icon rotate on click.', YSP_COMPANION_TEXT_DOMAIN),
        );
        
        $params[] = array(
            'type' => 'textfield',
            'heading' => __('Icon End | New Icon', YSP_COMPANION_TEXT_DOMAIN),
            'param_name' => 'icon_change_end',
            'value' => '',
            'group' => esc_html__( 'Icon End', YSP_COMPANION_TEXT_DOMAIN ),
            'description' => __('Add new icon on click.', YSP_COMPANION_TEXT_DOMAIN),
        );

    }
    // Plugin Check End

    $params[] = array(
        'type' => 'dropdown',
        'heading' => __('Collapse', YSP_COMPANION_TEXT_DOMAIN),
        'admin_label' => true,
        'param_name' => 'collapse',
        'value' => array(
            __( 'Always', YSP_COMPANION_TEXT_DOMAIN ) => '',
            __( 'Never', YSP_COMPANION_TEXT_DOMAIN ) => 'never',
            __( 'XS', YSP_COMPANION_TEXT_DOMAIN ) => 'xs',
            __( 'SM', YSP_COMPANION_TEXT_DOMAIN ) => 'sm',
            __( 'MD', YSP_COMPANION_TEXT_DOMAIN ) => 'md',
            __( 'LG', YSP_COMPANION_TEXT_DOMAIN ) => 'lg',
        ),
        'std' => 'sm',
        'group' => esc_html__( 'Advanced', YSP_COMPANION_TEXT_DOMAIN ),
        'description' => __( 'Choose when the items should collapse; default: XS', YSP_COMPANION_TEXT_DOMAIN ),
    );

    $params[] = array(
        'type' => 'textfield',
        'heading' => __( 'Custom CSS class', YSP_COMPANION_TEXT_DOMAIN ),
        'admin_label' => true,
        'param_name' => 'class',
        'value' => '',
        'group' => esc_html__( 'Advanced', YSP_COMPANION_TEXT_DOMAIN ),
        'description' => __( 'Add custom class', YSP_COMPANION_TEXT_DOMAIN ),
    );

    // Add Margins and Paddings
    $params = array_merge( $params, ysp_vc_spacing_params() );

    vc_map(
        array(
            'name'          =>  __( 'Widget Accordion', YSP_COMPANION_TEXT_DOMAIN ),
            'description'   =>  __( 'Display a widget with the accordion functionality.', YSP_COMPANION_TEXT_DOMAIN ),
            'base'          =>  'ysp_widget_accordion',
            'category'      =>  __( 'Yourstyle', YSP_COMPANION_TEXT_DOMAIN ),
            'icon'          =>  YSP_VC_COMPONENT_SYMBOL,
            'params'        =>  $params
        )
    );
}